import React from 'react'
import { Modal, Spin, Form, Button } from 'igroot'

const { Item } = Form

class _InsterFrom extends React.Component {
  render() {
    return (
      <Form>
        {this.props.renderForm()}
      </Form>
    )
  }
}

const InsterFrom = Form.create()(_InsterFrom)

export default class FormModal extends React.Component {
  static Item = Item

  state = {
    visible: false,
    loading: false
  }

  render() {
    const props = this.props
    const { visible, loading } = this.state
    const footers = [
      <Button size='large' onClick={this.cancel} key='cancel'>取消</Button>,
      <Button size='large' loading={loading} onClick={this.ok} type='primary' key='sure'>确定</Button>
    ]

    return (
      <Modal
        onOk={this.ok}
        onCancel={this.cancel}
        visible={visible}
        footer={footers}
        width={900}
        {...props}
      >
        <Spin spinning={loading}>
          <InsterFrom renderForm={this.renderForm} ref={vDom => this.form = vDom} />
        </Spin>
      </Modal>
    )
  }

  ok = () => {
    const { validateFields } = this.form

    validateFields((err, val) => {
      if (err) return
      if (this.props.onOk) {
        this.setState({ loading: true })
        this.props.onOk(val, this.okCallBack)
      }
    })
  }

  cancel = () => this.setState({ visible: false })

  okCallBack = success => this.setState({
    visible: !success,
    loading: false
  })

  show = val => {
    this.setState({ visible: true })

    if (val) {
      setTimeout(() => {
        const { setFieldsValue } = this.form
        setFieldsValue(val)
      }, 0)
    }
  }
}
